import org.junit.Test;

import java.util.*;

import static org.junit.Assert.assertEquals;

public class ClinicTest {
    @Test
    public void testListToBST() {
        LinkedList<String> ll = new LinkedList<>();
        ll.add("Lily");
        ll.add("Norris");
        ll.add("Benjamin");
        ll.add("Harry");
        ll.add("Eric");
        ll.add("Voravich");
        ll.add("Zac");
        Collections.sort(ll);

        Clinic.Node root = Clinic.listToBST(ll);

        // Order: [Lily, Eric, Voravich, Benjamin, Harry, Norris, Zac]
        assertEquals(root.value, "Lily");
        assertEquals(root.left.value, "Eric");
        assertEquals(root.right.value, "Voravich");
        assertEquals(root.left.left.value, "Benjamin");
        assertEquals(root.left.right.value, "Harry");
        assertEquals(root.right.left.value, "Norris");
        assertEquals(root.right.right.value, "Zac");
    }

    @Test
    public void testTreatmentOrder() {
        List<Clinic.Patient> list = new ArrayList<>();
        list.add(new Clinic.Patient("Lily", 1, false));
        list.add(new Clinic.Patient("Zac", 2, false));
        list.add(new Clinic.Patient("Norris", 10, false));
        list.add(new Clinic.Patient("Voravich", 10, true));
        list.add(new Clinic.Patient("Harry", 7, false));
        list.add(new Clinic.Patient("Eric", 2, false));
        list.add(new Clinic.Patient("Benjamin", 5, true));

        PriorityQueue<Clinic.Patient> actual = Clinic.treatmentOrder(list);

        // Order: [Voravich, Norris, Harry, Benjamin, Eric, Zac, Lily]
        String[] expected = {"Voravich", "Norris", "Harry", "Benjamin", "Eric", "Zac", "Lily"};
        for (String name: expected) {
            assertEquals(name, Objects.requireNonNull(actual.poll()).name());
        }
    }
}